// mt.h: interface for the mt class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MT_H__ACEEC7B1_737B_11D4_A831_0000778B5536__INCLUDED_)
#define AFX_MT_H__ACEEC7B1_737B_11D4_A831_0000778B5536__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define NERRS	54
#define PRESENTGRP	0
#define TESTERGRP	1
#include "Tester.h"
struct ERRNAM {
	char			ErrName[65];
	unsigned char	SAE_byte1;	
	unsigned char	SAE_byte2;	
	}; 


struct DTPARAMS
{
	int		StartFREQ;
	int		StopFREQ;

	int		BeginFREQ;
	int		EndFREQ;
	int		BeginSpeed;
	int		EndSpeed;
	int		BeginTWAT;
	int		EndTWAT;
	float	BeginFUEL;
	float	EndFUEL;
	float	BeginFUELK;
	float	EndFUELK;
	float	BeginAIR;
	float	EndAIR;
	DWORD	TestTime;
};

struct DTDUMP
{
	BOOL			FILL;
	int				FREQ;
	int				Speed;
	int				TWAT;
	float			FUEL;
	float			FUELK;
	float			AIR;
	DWORD			Time;
};

class mt  
{
public:
	mt();
	virtual ~mt();

	short			_TWAT;
	short			_TAIR;
	float			_VALF;
	unsigned char	_THR;
	unsigned int	_FREQ;
	unsigned int	_FREQXX;
	unsigned char	_UNN;
	unsigned char	_FSM;
	float			_COEFF1;
	float			_COEFF2;
	char			_UOZ;
	float			_UOZOC;
	unsigned char	_SPD;
	unsigned char	SR;
#define		SRMAX	10
	float			_NUACC;
	float			_O2U;
	unsigned char	_O2FLAGS;
	float			_INJ;
	float			_JAIR;
	float			_JQT;
	float			_JQK;
	unsigned char	_JEGR;
	unsigned char	_JADS;

	/*        */
	float			_RCOK;
	float			_RCOD;
	unsigned char	_SSM;
	float			_UGB;
	unsigned char	_FAZ;
	
/**************************************************/
	
	BOOL			_F1;
	BOOL			_F2;
	BOOL			_F3;
	BOOL			_F4;
	unsigned char	FORx;
	unsigned char	PORTx;
	unsigned char	PORTc;
	unsigned char	PROGx;
	unsigned char	Lc;
	unsigned char	Mc;
	BOOL			_I14;
	BOOL			_I23;
	UINT			_RDV;
	UINT			_JDMM;
	BOOL			_EBN;
	BOOL			_CONDITION;
	BOOL			_FAN;
	BOOL			_CHECKEIGINE;

	BOOL			_BITSTP;	//   	
	BOOL			_RXX;		//   	
	BOOL			_BLKINJ;	// Code=07   
	BOOL			_BITPOW;	//   	
	BOOL			_WRKLAM;	// Code=07    . 
	BOOL			_RDET;		// Code=07      

	BOOL			_ADSORBER;	// Code=08   
	BOOL			_BITATM;	// Code=08     
	BOOL			_TKFWR1;	// Code=08     TABKF1
	BOOL			_TKFWR2;	// Code=08     TABKF2
	BOOL			_INPLAM1;	// Code=08 . 1 L- (1-./0-. 
	BOOL			_INPLAM2;	// Code=08 . 2 L- (1-./0-. 
	BOOL			_DET;		// Code=08  ,
	UINT			_LAM1;		// 
	UINT			_LAM2;		// 
	UINT			_PABS;		//    
	UCHAR			_BDET;

	BOOL			FREQXXChanged; 
	BOOL			RDVChanged;
	BOOL			AdsorberExist;	 
	BOOL			SpeedSensorExist;		
	BOOL			RecyclValveExist; 
	BOOL			PhaseSensorExist; 
	BOOL			CnockSensorExist; 
	BOOL			TAIRSensorExist;
	BOOL			COResistorExist;
	BOOL			LZondExist;
	

					COMPLECTATION(CString *m_COMPLECTATION);
	char			ReadParams();
	unsigned char	TesterPresent();
	unsigned char	TryConnect();
	unsigned char	GetFORX();
					SetTesterStateText(CString);
					OnStart();
					OnCheckeigine(BOOL *m);

					OnEbn(BOOL *m);
					OnCondition(BOOL *m);
					OnAdsorber(BOOL *m);
					OnFan(BOOL *m);

	float			OnSaveUOZC(float m); 
	int				StoreParam(unsigned char a); 
	float			StoreUOZC(); 
	float			StoreRCOD(); 
	float			StoreRCOK(); 
					OnSaveRdv(unsigned int m); 
					OnSaveFreqxx(unsigned int m); 
	float			OnSaveRCOD(float m); 
	float			RCOxChg(int pos,float RCOD);
	float			OnSaveRCOK(float m); 
	unsigned int	OnSaveJEGR(unsigned int m); 
	unsigned int	OnSaveJADS(unsigned int m); 
	int				OnLZond(BOOL *m);
	int				OnDeton(BOOL *m);
	BOOL			ClrDetonAdopt();
	BOOL			ClrLZondAdopt();

	int				SendCommand(char *command,char len, char *response, char rlen);
	BOOL			ReadVIN();
	void			ReadErrors();
	void			ReadControls();
	void			ClearErr();
	void			SetF1 (BOOL *m);
	void			SetF2 (BOOL *m);
	void			SetF3 (BOOL *m);
	void			SetF4 (BOOL *m);
	void			SetI14(BOOL *m);
	void			SetI23(BOOL *m);
	void			RetCtrl();
	void			SetM154N(BOOL m);
	void			GetERRORS  (CString	*ErrString);
	void			GetERRORS_L(CString *ErrString); 

	char			DoDinamicsTest(struct DTPARAMS *DTPar, DTDUMP *DumpPtr,unsigned int MAX_LOOP);
	char			DoMechTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size);
	char			DoAAccTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size);
	char			DoLAccTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size); 
					Closemt();

	BOOLEAN			Connected;  //  .	
	char			NErr;			//  .
	struct			{
						unsigned char	byte1;
						unsigned char	byte2;
					} Errors[NERRS];
struct VIN {
	char	Present;
	char	MikasType[21];
	char	progPasp[49+8];
	char	dataPasp[81+8];
	char	vNAMEBL[18];
	char	vNUMBL[18];
	char	vDATBL[18];
	char	vKADC0[18];
	char	vNUMENG[18];
	char	vNUMCAR[18];
	char	vDATENG[18];

};
	struct			VIN sVIN;

	BOOL			M154N;
	CString			StateText;

private:
	char			ConnectErrors, tst;
	BOOL			InjectorUnderControl[4],Ign14UnderControl,Ign23UnderControl,CEUnderControl;
	BOOL			ConditionerUnderControl,AdsorberUnderControl,EBNUnderControl,FANUnderControl;
	BOOL			RDVUnderControl,FREQXXUnderControl;
	unsigned char	O2offset;
	BOOL			WasCommStart;
	BOOL			FirstO2;
	unsigned char	StartMessage[BUFF_LEN];
	unsigned char	StopMessage[BUFF_LEN];
	void			SaveRes(struct DTDUMP *DTPar);
	void			onLooseConnect();
					StartSession();
	unsigned char	StopCommunication();
	unsigned char	StopSession();
					STA_SetControl(char State, char ioLocalID,UINT *DlgItem,BOOL *UnderControl);
	void			ECO_SetControl(char State, char ioLocalID,BOOL *DlgItem,BOOL *UnderControl);
					ECO_ON_OFF_SetControl(char ioLocalID,BOOL *DlgItem,BOOL *UnderControl);
	unsigned int	ECO_ReadControl(char ioLocalID);
	int				ReadState(void);
	char			*GetString(unsigned char byte1,unsigned char byte2);
	CString			*GetEType(CString *s, unsigned char byte2);
	unchar			SetPresentGrp();
	unchar			SetTesterGrp();
	BOOL			IdlePresent;
	char			Grp;
	void			OnStopTest();
	void			OnStartTest();
};



#endif // !defined(AFX_MT_H__ACEEC7B1_737B_11D4_A831_0000778B5536__INCLUDED_)
