// MechanicTest.cpp : implementation file
//

#include "stdafx.h"
#include "MYTESTER.h"
#include "mt.h"
#include "MechanicTest.h"
#include "ommentDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MechanicTest dialog


MechanicTest::MechanicTest(CWnd* pParent /*=NULL*/)
	: CDialog(MechanicTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(MechanicTest)
	m_BeginFREQ = 0;
	m_EndFREQ = 0;
	m_FREQACC = 0.0f;
	m_Save = FALSE;
	m_SPEEDACC = 0.0f;
	m_STARTFREQ = 5000;
	m_STOPFREQ = 2000;
	m_TWAT = 0;
	m_TIME = 0.0f;
	//}}AFX_DATA_INIT
}


void MechanicTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MechanicTest)
	DDX_Control(pDX, IDC_StartButton, m_START_BUTTONc);
	DDX_Text(pDX, IDC_BEGIN_FREQ, m_BeginFREQ);
	DDX_Text(pDX, IDC_END_FREQ, m_EndFREQ);
	DDX_Text(pDX, IDC_FREQACC, m_FREQACC);
	DDX_Check(pDX, IDC_MSAVE, m_Save);
	DDX_Text(pDX, IDC_SPEEDACC, m_SPEEDACC);
	DDX_Text(pDX, IDC_START_FREQ, m_STARTFREQ);
	DDX_Text(pDX, IDC_STOP_FREQ, m_STOPFREQ);
	DDX_Text(pDX, IDC_TWAT, m_TWAT);
	DDX_Text(pDX, IDC_TIME, m_TIME);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MechanicTest, CDialog)
	//{{AFX_MSG_MAP(MechanicTest)
	ON_BN_CLICKED(IDC_StartButton, OnStartButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

extern mt *Tstr;
//extern struct DTPARAMS DTPar; 
extern CString	Filename;
extern char szFilter[];
extern BOOL		IdleTimer;


/////////////////////////////////////////////////////////////////////////////
// MechanicTest message handlers

#define MAX_LOOP	2000


void MechanicTest::OnStartButton() 
{
char Res;	
FILE	*stream;
time_t	ltime;
DTDUMP *DumpStart,*DumpPtr;

	UpdateData(TRUE);
	if ((m_STOPFREQ) > 3000) {MessageBox("     3000.","  ", MB_OK | MB_ICONSTOP ); return;}
	if ((m_STARTFREQ) < 3000) {MessageBox("      3000.","  ", MB_OK | MB_ICONSTOP ); return;}
//	if (m_STARTFREQ<=m_STOPFREQ) {MessageBox("          1000.","  ", MB_OK | MB_ICONSTOP ); return;}
	if ((m_STARTFREQ-m_STOPFREQ)<1000) {MessageBox("          1000.","  ", MB_OK | MB_ICONSTOP ); return;}
	DTPar.StartFREQ=m_STARTFREQ;
	DTPar.StopFREQ=m_STOPFREQ;
	m_START_BUTTONc.EnableWindow(FALSE);

	DumpPtr=DumpStart=(DTDUMP *)malloc(sizeof(DTPar)*(MAX_LOOP+3));
	Res=Tstr->DoMechTest(&DTPar,DumpStart,MAX_LOOP);
	IdleTimer=FALSE;

	m_START_BUTTONc.EnableWindow(TRUE);
	if (Res) 
	{
		if (Res==-1) {MessageBox("    ","  ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-2) {MessageBox("  < 5000 /."," .", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-3) {MessageBox(".    ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-4) {MessageBox(".    ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-5) {MessageBox("     ."," ", MB_OK | MB_ICONSTOP ); return;}
	}
	m_TIME=((float)DTPar.TestTime)/1000,0;
	m_BeginFREQ=DTPar.BeginFREQ;
	m_EndFREQ=DTPar.EndFREQ;
	m_TWAT =(DTPar.EndTWAT-DTPar.BeginTWAT);
	m_SPEEDACC=((float)DTPar.BeginSpeed-(float)DTPar.EndSpeed)/m_TIME;
	m_FREQACC =(float)((float)DTPar.BeginFREQ-(float)DTPar.EndFREQ)  /m_TIME;
	UpdateData(FALSE);
	if (m_Save)
	{
		if ( Filename.GetLength() < 1 )	{ CFileDialog CF( FALSE, ".tdm", "TSTRDMP", OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_CREATEPROMPT|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilter, NULL );	CF.DoModal(); Filename=CF.GetPathName();}


		if( (stream = fopen(Filename,"ab")) == NULL ) {MessageBox("   ."," ", MB_OK | MB_ICONSTOP ); return;}
		else {		
		fprintf(stream, "\r\n\r\n \t ********************************************* \r\n");
		fprintf(stream,         " \t ***    . *** \r\n");
		fprintf(stream,         " \t ********************************************* \r\n\t\t:");
        time( &ltime ); fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));
CommentDlg	CD;
	CD.DoModal();
		if (CD.m_Comment.GetLength()!=0) fprintf(stream, ": %s\r\n", CD.m_Comment );

		fprintf(stream,"\r\n\r\n  :\t%.4f\tc.", m_TIME );   

		fprintf(stream,"\r\n    : %4i\t: %4i\t..", DTPar.BeginTWAT, DTPar.EndTWAT );
		fprintf(stream,"\r\n         : %4u\t: %4u\t./.", DTPar.BeginFREQ, DTPar.EndFREQ );   
		fprintf(stream,"\r\n                : %3u\t: %3u\t./.", DTPar.BeginSpeed,DTPar.EndSpeed );   
		fprintf(stream,"\r\n              : %.3f\t: %.3f\t./100.", DTPar.BeginFUELK,DTPar.EndFUELK );   
		fprintf(stream,"\r\n              : %.2f\t: %.2f\t./.",  DTPar.BeginFUEL, DTPar.EndFUEL );

		fprintf(stream,"\r\n\r\n   :\t\t%.4f\t(./)/c.", m_FREQACC );   
		fprintf(stream,"\r\n  :\t\t\t%.4f\t(./)/cek.", m_SPEEDACC );   

		char *strptr;
		strptr=(char *)malloc(256);	*strptr=0;
		
		strcpy (strptr,asctime(localtime(&ltime )) ); 
		sprintf(strptr,"%lu",time( &ltime ));
		strcat (strptr,".dmm");
			
		fprintf(stream,"\r\n  : %s", strptr );

		fclose(stream);
		if( (stream = fopen(strptr,"ab")) == NULL ) {MessageBox("    ."," ", MB_OK | MB_ICONSTOP ); 
														free(strptr);free(DumpStart);return;}
		else {		
			fprintf(stream, "\r\n\r\n \t ********************************************************* \r\n");
			fprintf(stream,         " \t ***         Exel.   *** \r\n");
			fprintf(stream,         " \t ********************************************************* \r\n\t\t:");
			time( &ltime ); fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));

			fprintf(stream,"\r\n   \t  \t \t  \t  \t  \t  ms.\r\n");
		
		do {
			fprintf(stream,"%i\t%u\t%u\t%0.4f\t%0.4f\t%0.3f\t%lu\r\n", DumpPtr->TWAT, DumpPtr->FREQ, DumpPtr->Speed, 
															 DumpPtr->FUELK, DumpPtr->AIR, DumpPtr->FUEL, DumpPtr->Time);
			DumpPtr++;
		} while (DumpPtr->FILL==TRUE);
			fclose(stream);
			free(strptr);
			free(DumpStart);
		}

		}

	}	
}




