// mt.cpp: implementation of the mt class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MYTESTER.h"

#include "mt.h"
//#include "TestingDlg.h"
#include "DinamicsTest.h"
#include "tester.h"
#include "uart.h"
#include "mtliter.h"

//

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern BOOL	IdleTimer;
int COM_Port=0;
uart	*urt;
uart	uart;

static  char String[122];

/********************************************************************************************/

mt::mt()
{
	M154N=TRUE; O2offset=2; FREQXXChanged=FALSE, RDVChanged=FALSE;
	ConnectErrors=0, tst=0;
	InjectorUnderControl[1]=0;InjectorUnderControl[2]=0;
	InjectorUnderControl[3]=0;InjectorUnderControl[4]=0;
	Ign14UnderControl=0;Ign23UnderControl=0;CEUnderControl=0;
	ConditionerUnderControl=0;AdsorberUnderControl=0;EBNUnderControl=0;FANUnderControl=0;
	RDVUnderControl=0; FREQXXUnderControl=0;
	Connected=FALSE;
	WasCommStart=FALSE;
	IdlePresent=FALSE; 
	urt=&uart;
	NErr=0;
	FirstO2=TRUE;
	_FAZ = 0; _COEFF1 = 0.0f; _COEFF2 = 0.0f; _LAM1 = 0;_LAM2 = 0;
	_DET = FALSE;		_FREQ = 0; 		_INJ = 0.0f;	_JAIR = 0.0f;
	_JQK = 0.0f;		_JQT = 0.0f;		_NUACC = 0.0f;	_SPD = 0;	_TAIR = 0;
	_THR = 0;			_UOZ = 0;			_VALF = 0.0f;	_FSM = 0;	_BITSTP = FALSE;
	_TWAT = 0;			_BLKINJ=FALSE;	_BITPOW=FALSE;	_RXX = FALSE;	_UOZOC=0;
	_UNN = 0;			
	_F1 = TRUE;			_F2 = TRUE;		_F3 = TRUE;		_F4 = TRUE;
	_I14 = TRUE;		_I23 = TRUE;		_RDV = 0;		_EBN = TRUE;	_CHECKEIGINE = FALSE;
	_CONDITION=FALSE;	_ADSORBER=FALSE;	_FAN = FALSE;	_O2U = 0.0f;	_O2FLAGS = 0;		_FREQXX = 0;
	_RCOD=_RCOK=_JEGR=_JADS=_JDMM=0;
	SR=0;
	Grp=-1;
	SpeedSensorExist=FALSE; PORTc=PORTx=FORx=Lc=Mc=PROGx=0;
	AdsorberExist=FALSE;RecyclValveExist=FALSE; PhaseSensorExist=FALSE; CnockSensorExist=FALSE; 
	LZondExist=FALSE; TAIRSensorExist=FALSE;	COResistorExist=FALSE; 
	sVIN.Present=0;
}

/********************************************************************************************/

mt::~mt() {}

/********************************************************************************************/
mt::Closemt()
{
RetCtrl(); 
Sleep(100);
StopCommunication();
Connected=FALSE;
onLooseConnect();
Sleep(200);
urt->CloseUart();
sVIN.Present=0;
NErr=0;
}

/***********************************************************************/
void mt::onLooseConnect()
{
	sVIN.Present=0;	
	Connected=FALSE; 
	NErr=0;
	M154N=TRUE; O2offset=2; FREQXXChanged=FALSE, RDVChanged=FALSE;
	ConnectErrors=0, tst=0;
	InjectorUnderControl[1]=0;InjectorUnderControl[2]=0;
	InjectorUnderControl[3]=0;InjectorUnderControl[4]=0;
	Ign14UnderControl=0;Ign23UnderControl=0;CEUnderControl=0;
	ConditionerUnderControl=0;AdsorberUnderControl=0;EBNUnderControl=0;FANUnderControl=0;
	RDVUnderControl=0;FREQXXUnderControl=0;
	WasCommStart=FALSE;
	IdlePresent=FALSE; 
	NErr=0;
	FirstO2=TRUE;
	_FAZ = 0; _COEFF1 = 0.0f; _COEFF2 = 0.0f; _LAM1 = 0;_LAM2 = 0;
	_DET = FALSE;		_FREQ = 0;		_INJ = 0.0f;	_JAIR = 0.0f;
	_JQK = 0.0f;		_JQT = 0.0f;		_NUACC = 0.0f;	_SPD = 0;		_TAIR = 0;
	_THR = 0;			_UOZ = 0;			_VALF = 0.0f;	_FSM = 0;		_BITSTP = FALSE;
	_TWAT = 0;			_BLKINJ=FALSE;	_BITPOW=FALSE;	_RXX = FALSE;		_UOZOC=0;
	_UNN = 0;			
	_F1 = TRUE;			_F2 = TRUE;		_F3 = TRUE;		_F4 = TRUE;
	_I14 = TRUE;		_I23 = TRUE;		_RDV = 0;		_EBN = TRUE;	_CHECKEIGINE = FALSE;
	_CONDITION=FALSE;	_ADSORBER=FALSE;	_FAN = FALSE;	_O2U = 0.0f;	_O2FLAGS = 0;		_FREQXX = 0;
	_RCOD=_RCOK=_JEGR=_JADS=_JDMM=0;
	SR=0;
	Grp=-1;
	SpeedSensorExist=FALSE; PORTc=PORTx=FORx=Lc=Mc=PROGx=0;
	AdsorberExist=FALSE;	RecyclValveExist=FALSE; PhaseSensorExist=FALSE; CnockSensorExist=FALSE; 
	LZondExist=FALSE; TAIRSensorExist=FALSE;	COResistorExist=FALSE;	SpeedSensorExist=FALSE;	
	StateText="***  ";
	sVIN.Present=0;
}

int mt::SendCommand(char *command,char len, char *response, char rlen) 
{	
	int i;
if (len<0) return 0;
IdleTimer=TRUE;
	Sleep(1000);
	memset(urt->rMessage,0,100);
	for (i=0;i<len;i++) 	urt->sMessage[i]=*(command+i); 
	urt->SendBytesGAZ(len);	
	urt->SetRxTimeOut(200); 
	urt->ReceiveBytes();
	if(!urt->FrameNotReceived) { memcpy(response,urt->rMessage,rlen); IdleTimer=FALSE;	return -1;}
IdleTimer=FALSE;
return 0;
}

/* BMW specific Part */

/********************************************************************************************/

char *mt::GetString(unsigned char byte1,unsigned char byte2)
{int  	i=1;
	for(i=0; i<=NCODES; i++)
		if ((byte1==mErrNames[i].SAE_byte1) /*&& (byte2==mErrNames[i].SAE_byte2)*/) 
															return mErrNames[i].ErrName;
	return UnnownStr;
}

/********************************************************************************************/

CString *mt::GetEType(CString *s, unsigned char byte2)
{*s="";
	if ( byte2 & 0x20 ) *s+="= .";
	if ( byte2 & 0x40 ) *s+=" = .";
return s;
}

/********************************************************************************************/
void mt::GetERRORS(CString	*ErrString) {	
unsigned char  	 ErrCntr=1;	
if (!Connected) {*(ErrString)=""; return;}
	if (NErr==0) { *(ErrString)="***   ***"; }
	else {
		*(ErrString)="";
        for(ErrCntr=0; ErrCntr<NErr; ErrCntr++)
			{/*    		*/
//            sprintf((char *)String, " P%02x%02x,",Errors[ErrCntr].byte1, Errors[ErrCntr].byte2);
            sprintf((char *)String, " %03i:%02x,",Errors[ErrCntr].byte1, Errors[ErrCntr].byte2);
			*(ErrString)+=(LPCSTR)String;
			}
	}
}

/********************************************************************************************/
void mt::GetERRORS_L(CString *ErrString){ 
	CString s;
unsigned char  	 ErrCntr=1;
if (!Connected) {*(ErrString)=""; return;}
	if (NErr==0) { *(ErrString)="***   ***"; }
	else {
		*(ErrString)="";
        for(ErrCntr=0; ErrCntr<NErr; ErrCntr++)
		{/*      	*/
//		sprintf((char *)String, "\r\n %02x%02x: %s.", Errors[ErrCntr].byte1, Errors[ErrCntr].byte2, GetString(Errors[ErrCntr].byte1, Errors[ErrCntr].byte2));
		GetEType(&s,Errors[ErrCntr].byte2);
			sprintf((char *)String, "\r\n %03i:%02x: %s %s.", Errors[ErrCntr].byte1, Errors[ErrCntr].byte2, 
			GetString(Errors[ErrCntr].byte1, Errors[ErrCntr].byte2), 
			LPCSTR(s) );
		*(ErrString)+=(LPCSTR)String;
		}
	}
}
/********************************************************************************************/
void	mt::ReadErrors(){      

/*  .        ,     
    ,   -  0xE0.	[N_ERR][ERRCODE1]0xE0 [ERRCODE2] 0xE0  [ERRCODEN] 0xE0*/

if (!Connected) return;
	urt->sMessage[0]=GETERR; urt->SendBytesGAZ(1);	urt->SetRxTimeOut(200);  urt->ReceiveBytes();	
	if((!urt->FrameNotReceived)) 
	{ /*    . */	
	NErr=urt->rMessage[0];
	if(NErr!=0)
	{for(unsigned char ErrCntr=0;ErrCntr<NErr;ErrCntr++)
		{Errors[ErrCntr].byte1=urt->rMessage[1+(ErrCntr)*2];Errors[ErrCntr].byte2=urt->rMessage[2+(ErrCntr)*2];}
	}
	}
return;
}
/***********************************************************************/
void mt::ClearErr() 
{	//      
	Sleep(100);
	urt->sMessage[0]=0x62;	urt->sMessage[1]=0x0E;	urt->sMessage[2]=0x08;	urt->SendBytesGAZ(3);  
	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
/*    if((!urt->FrameNotReceived) )	{     if (urt->rMessage[0]!=0) StateText=".    1."; } */
	Sleep(100);
	urt->sMessage[0]=0x62;	urt->sMessage[1]=0x0E;	urt->sMessage[2]=0x00;	urt->SendBytesGAZ(3);  
	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
 /*   if((!urt->FrameNotReceived) )	{ if (urt->rMessage[0]!=0) 	StateText=".    2.";	}*/
NErr=0;  
}
/***********************************************************************/

				      
mt::COMPLECTATION(CString *m_COMPLECTATION) 
{ //     .
int	i;

*(m_COMPLECTATION)="";
if (!Connected) return 0;
	AdsorberExist=FALSE;	 
	RecyclValveExist=FALSE; 
	PhaseSensorExist=FALSE; 
	CnockSensorExist=FALSE; 
	TAIRSensorExist=FALSE;
	COResistorExist=FALSE;
	SpeedSensorExist=FALSE;		

	urt->sMessage[0]=CREADP; urt->sMessage[1]=01; urt->sMessage[2]=02; urt->sMessage[3]=03; urt->sMessage[4]=04; urt->sMessage[5]=05;  
	urt->SendBytesGAZ(6);	
	urt->SetRxTimeOut(200); urt->ReceiveBytes();

	if(!urt->FrameNotReceived) 
	{ //   .
	i=0;
	if((urt->rMessage[0]&TYPBAT))	{ *(m_COMPLECTATION)+="  , ";}
	if((urt->rMessage[0]&TYPLAM))	{*(m_COMPLECTATION)+="\r\nL-, "; LZondExist=TRUE;  i++; }
	if((urt->rMessage[0]&TYPDET))	{*(m_COMPLECTATION)+="\r\n , "; CnockSensorExist=TRUE; i++; }
	if((urt->rMessage[0]&TYPTAI))	{*(m_COMPLECTATION)+="\r\n  , "; TAIRSensorExist=TRUE; i++; }
	if((urt->rMessage[0]&TYPFAZ))	{*(m_COMPLECTATION)+="\r\n , "; PhaseSensorExist=TRUE; i++; }
	if((urt->rMessage[0]&TYPPFAZ))	{*(m_COMPLECTATION)+="\r\n.     , "; i++; }
	if((urt->rMessage[0]&TYPSPD))	{*(m_COMPLECTATION)+="\r\n , "; SpeedSensorExist=TRUE; i++; }
	if((urt->rMessage[0]&TYPRCO))	{*(m_COMPLECTATION)+="\r\n RCO, "; i++; }
	if((urt->rMessage[1]&TYPPBS))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	if((urt->rMessage[1]&TYPSEGR))	{*(m_COMPLECTATION)+="\r\n   EGR, "; i++; }
	if((urt->rMessage[1]&TYPSADS))	{*(m_COMPLECTATION)+="\r\n   ADS, "; i++; }
	if((urt->rMessage[1]&TYPSTEER))	{*(m_COMPLECTATION)+="\r\n   , "; i++; }
	if((urt->rMessage[2]&TYPIROM))	{*(m_COMPLECTATION)+="\r\n  IROM, "; i++; }
	if((urt->rMessage[2]&TYPKADC))	{*(m_COMPLECTATION)+="\r\n.    IROM, "; i++; }
	if((urt->rMessage[2]&TYPIMMOB))	{*(m_COMPLECTATION)+="\r\n, "; i++; }
	if((urt->rMessage[2]&TYPERCO))	{*(m_COMPLECTATION)+="\r\n. RCO  IROM, "; i++; }
	if((urt->rMessage[2]&TYPFUE))	{*(m_COMPLECTATION)+="\r\n  , "; i++; }
	if((urt->rMessage[2]&TYPAINJ))	{*(m_COMPLECTATION)+="\r\n    , "; i++; }
	if((urt->rMessage[2]&TYPATHR))	{*(m_COMPLECTATION)+="\r\n.  , "; i++; }
	if((urt->rMessage[2]&TYPAXX))	{*(m_COMPLECTATION)+="\r\n.    , "; i++; }
	if((urt->rMessage[3]&TYPUGB))	{*(m_COMPLECTATION)+="\r\n.   , "; i++; }
	if((urt->rMessage[4]&TYPALA))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	if((urt->rMessage[4]&TYPPOM))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	if((urt->rMessage[4]&TYPPFOR))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	if((urt->rMessage[4]&TYPEGR))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	if((urt->rMessage[4]&TYPADS))	{*(m_COMPLECTATION)+="\r\n, "; i++; }
	if((urt->rMessage[4]&TYPTAH))	{*(m_COMPLECTATION)+="\r\n, "; i++; }
	if((urt->rMessage[4]&TYPQT))	{*(m_COMPLECTATION)+="\r\n  , "; i++; }
	if((urt->rMessage[4]&TYPKON))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	if((urt->rMessage[5]&TYPFAN))	{*(m_COMPLECTATION)+="\r\n, "; i++; }
	if((urt->rMessage[5]&TYPKPR))	{*(m_COMPLECTATION)+="\r\n , "; i++; }
	return -1;
	}
return 0;
}

/***********************************************************************/
unchar mt::TesterPresent(){ 
	if (IdlePresent) return 1;
	if (Grp!=PRESENTGRP) SetPresentGrp();
	urt->sMessage[0]=CREADL; urt->SendBytesGAZ(1);	
	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if(!urt->FrameNotReceived) 	return 1;
/*/*/	else Connected=FALSE;
return 0;
}

/***********************************************************************/
mt::StartSession()	{return 1;}
/***********************************************************************/
unchar mt::StopSession() {  return 1;}
/***********************************************************************/
unchar mt::StopCommunication(){  return 1; }
/***********************************************************************/
mt::SetTesterStateText(CString Text) {	StateText=Text;		}
/***********************************************************************/
unchar mt::TryConnect()
{
//*/*/ Connected=TRUE; 	return 1;
	urt->sMessage[0]=MIDENT; urt->SendBytesGAZ(1);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if(!urt->FrameNotReceived) 
	{ //   .
		Connected=TRUE; 
		switch(urt->rMessage[0])
		{case MVer54:	StateText="  5.4. "; strcpy(sVIN.MikasType," 5.4"); break;
		 case MVer71:	StateText="  7.1. "; strcpy(sVIN.MikasType," 7.1"); break;
		 default:		StateText=" . "; strcpy(sVIN.MikasType," ?.?");
		}
	}
/*/*/else Connected=FALSE; 
	SetPresentGrp();
return Connected;
}
/***********************************************************************/
unchar mt::SetPresentGrp()
{
	urt->sMessage[0]=CWRITL; urt->sMessage[1]=pTHR;	urt->SendBytesGAZ(2);
	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	Grp=PRESENTGRP;
	if(!urt->FrameNotReceived) { 	Connected=TRUE; 	}
/*/*/else Connected=FALSE; 
	Sleep(50);
	return 1;
}

unchar mt::SetTesterGrp()
{
int i,j;

	if (!Connected) return -1;
	j=i=0;
	IdlePresent=TRUE;
	Sleep(50);
	urt->sMessage[i++]=CWRITL; 
	oTWAT=j++;		urt->sMessage[i++]=pTWAT;	// 1 	Byte1-40   , 	
	oFREQ=j++;		urt->sMessage[i++]=pFREQ;	// 1 	Byte1*40   , -1	
	oJAIR=j++; j++;	urt->sMessage[i++]=pJAIR;	// 2 	(Byte2*256+Byte1)/100  , /	
	oJQT=j++;  j++;	urt->sMessage[i++]=pJQT;	// 2 	(Byte2*256+Byte1)/10   , /	
	oJSPEED=j++; 	urt->sMessage[i++]=pJSPEED;	// 1 
	urt->SendBytesGAZ(i);	urt->SetRxTimeOut(200); urt->ReceiveBytes();	
	Grp=TESTERGRP;
	Sleep(50);
	if(!urt->FrameNotReceived)		{ /*    . */		return 0;		}
SR=0;
return -1;
}


/***********************************************************************/
//*/*/ unsigned char tsts[]={0x84, 0x15, 0x53, 0x0, 0x85, 0x0, 0x10, 0x0, 0x8D, 0x0, 0x5, 0xF, 0xFA, 0x51, 0x51, 0x53, 0x0, 0x5B, 0x9C, 0x2, 0xB8, 0x0, 0x10, 0x0, 0x23, 0x0, 0x15, 0x0, 0x0, 0x57, 0x0, 0x9D, 0x0, 0xF9, 0xD }; 

char mt::ReadParams(void)
{
float	E;	
unsigned int	i,j,Word;

if(Connected)
{
IdleTimer=TRUE;
	for (char k=1;k<NRetrys;k++) {
		Sleep(100);
			//   readDataByLocalIndentifier.
	i=j=0;
		urt->sMessage[i++]=CREADP; 
		oTWAT=j++;		urt->sMessage[i++]=pTWAT;	// 1 	Byte1-40   , 	
		oFREQ=j++;		urt->sMessage[i++]=pFREQ;	// 1 	Byte1*40   , -1	
		oFREQXX=j++;	urt->sMessage[i++]=pFREQX;	// 1 	Byte1*10     .., -1		
		oUOZ=j++;		urt->sMessage[i++]=pUOZ;	// 1 	Byte1/2   , 		
		oMODE0=j++;		urt->sMessage[i++]=pMODE0;	// 1 	 	
		oMODE1=j++;		urt->sMessage[i++]=pMODE1;	// 1 	 	
		oEXBPORT=j++;	urt->sMessage[i++]=pEXBPORT;// 1 	 	
/* 8*/	oVALF=j++;		urt->sMessage[i++]=pVALF;	// 1 	0,5+Byte1/256    / 
		
		oUACC=j++;		urt->sMessage[i++]=pUACC;	// 1 	Byte1/10  , 	
		oTHR=j++;		urt->sMessage[i++]=pTHR;	// 1 	Byte1  , %	
	if (SR==0) {
		 oRCOK=j++;		urt->sMessage[i++]=pRCOK;	// 1 	|(Byte1-128)/256|-0,5   	
		 oRCOD=j++;		urt->sMessage[i++]=pRCOD;	// 1 	|(Byte1-128)/256|-0,5      	
		 oUOZOC=j++;		urt->sMessage[i++]=pUOZOC;	// 1 	Byte1/2  , 	
		 oJDMM=j++;		urt->sMessage[i++]=pJDMM;	//  -  
		 oJEGR=j++;		urt->sMessage[i++]=pJEGR;	//  .  2.
		 oJADS=j++;		urt->sMessage[i++]=pJADS;	//  .  2.
	}
		oSSM=j++;		urt->sMessage[i++]=pSSM;	// 1 	Byte1  , 	
		oFSM=j++;		urt->sMessage[i++]=pFSM;	// 1 	Byte1  , 
		oTAIR=j++;		urt->sMessage[i++]=pTAIR;	// 1 	Byte1-40  , 0	
		oJSPEED=j++;	urt->sMessage[i++]=pJSPEED;	// 1   
		oUGB=j++;		urt->sMessage[i++]=pUGB;	// 1 	(Byte2*256+Byte1)/100   , /	
/* 18*/	oINJ=j++;  j++;	urt->sMessage[i++]=pINJ;	// 2 	(Byte2*256+Byte1)/125  , 
		oJAIR=j++; j++;	urt->sMessage[i++]=pJAIR;	// 2 	(Byte2*256+Byte1)/100  , /	
		oJQT=j++;  j++;	urt->sMessage[i++]=pJQT;	// 2 	(Byte2*256+Byte1)/10   , /	

		oFAZ=j++;		urt->sMessage[i++]=pFAZ;			// 
		oBDET=j++;		urt->sMessage[i++]=pBDET;	// .  
		oPABS=j++; j++;	urt->sMessage[i++]=pPABS;	//   
		oLAM1=j++;		urt->sMessage[i++]=pJALAM1;	//   L- 1
		oLAM2=j++;		urt->sMessage[i++]=pJALAM2;	//   L- 2
		oCOEFF1=j++;	urt->sMessage[i++]=pCOEF1;	//  .  1.
		oCOEFF2=j++;	urt->sMessage[i++]=pCOEF2;	//  .  2.
		

		urt->SendBytesGAZ(i);
			//     100/200 ms 
		urt->SetRxTimeOut(200); urt->ReceiveBytes();	
//*/*/	memcpy(urt->rMessage,tsts,sizeof(tsts));urt->FrameNotReceived=0;
//*/*/FILE *stream; if(!urt->FrameNotReceived){stream=fopen("dumpa.dmp","ab"); fprintf(stream,"\r\n"); for(i=0;i<60;i++) fprintf(stream,"0x%X, ",(UINT)urt->rMessage[i]); }

		if(!urt->FrameNotReceived)
		{ //    .
			_TWAT=((short)urt->rMessage[oTWAT]-40); 			//  
			_FREQ=((unsigned int)urt->rMessage[oFREQ])*40;		//     
			if (!FREQXXChanged)	_FREQXX=((unsigned int)urt->rMessage[oFREQXX])*10; 
			_UOZ=((char)urt->rMessage[oUOZ])/2;					//   .
			E=(unsigned char)urt->rMessage[oUACC]; _NUACC=(E/10);		//   .
			_BITSTP=((urt->rMessage[oMODE0]&mBITSTP)!=0);		//   	
			_RXX =  ((urt->rMessage[oMODE0]&mRXX)!=0);			//   	
			_BLKINJ=((urt->rMessage[oMODE0]&mBLKINJ)!=0);		// Code=07   
			_BITPOW=((urt->rMessage[oMODE0]&mBITPOW)!=0);		//   	
			_WRKLAM=((urt->rMessage[oMODE0]&mWRKLAM)!=0);		// Code=07    . 
			_RDET = ((urt->rMessage[oMODE0]&mRDET)!=0);			// Code=07      
			//#define		mRFRSTA		0x02 					// Code=07     ., 	
			//#define		mRBLNOT		0x08					// Code=07     , 	
			_ADSORBER=((urt->rMessage[oMODE1]&mBADSPU)!=0);		// Code=08   
			_BITATM = ((urt->rMessage[oMODE1]&mBITATM)!=0);		// Code=08     
			_TKFWR1 = ((urt->rMessage[oMODE1]&mTKFWR1)!=0);		// Code=08     TABKF1
			_TKFWR2 = ((urt->rMessage[oMODE1]&mTKFWR2)!=0);		// Code=08     TABKF2
			_INPLAM1= ((urt->rMessage[oMODE1]&mINPLAM1)!=0);	// Code=08 . 1 L- (1-./0-. 
			_INPLAM2= ((urt->rMessage[oMODE1]&mINPLAM2)!=0);	// Code=08 . 2 L- (1-./0-. 
			_DET  =   ((urt->rMessage[oMODE1]&mDET)!=0);		// Code=08  ,
			//_RFRMIN=((urt->rMessage[oMODE1]&mRFRMIN)!=0);		// Code=08    . 
//			pEXBPORTstate=(urt->rMessage[oEXBPORT]);
			_CHECKEIGINE=((urt->rMessage[oEXBPORT]&mALA)!=0);	// Code=09 
			_CONDITION =((urt->rMessage[oEXBPORT]&mKON)!=0);	// Code=09 	
			_FAN=((urt->rMessage[oEXBPORT]&mFAN)!=0);			// Code=09  	
			_EBN=((urt->rMessage[oEXBPORT]&mPOM)!=0);			// Code=09 	
			_I14=((urt->rMessage[oEXBPORT]&mB1)!=0);			// Code=09 B1 	
			_I23=((urt->rMessage[oEXBPORT]&mB2)!=0);			// Code=09 B2 
			E=urt->rMessage[oVALF]; _VALF=(float)(0.5+(E)/(float)256) ;	//  /

			_THR=(unsigned char)urt->rMessage[oTHR];		//    %
			_SSM=urt->rMessage[oSSM];						// 1 	Byte1  , 	

			_FSM=(unsigned char)urt->rMessage[oFSM];		//  
			if (!RDVChanged) _RDV=_FSM;
			_TAIR=((unsigned short)urt->rMessage[oTAIR]-40);// 1 	Byte1-40  , 0	
			_SPD=(unsigned char)urt->rMessage[oJSPEED];		//  .
			_UGB=((float)(urt->rMessage[oUGB]))/10,0;		// (Byte2*2)/10   , /	
			Word=(((urt->rMessage[oINJ+1]<<8)|urt->rMessage[oINJ]));
			_INJ=((float)Word)/125;										//    (ms).
			Word=(((unsigned int)urt->rMessage[oJAIR+1]<<8)|urt->rMessage[oJAIR]);	//   .
			_JAIR=((float)Word)/10; 
			Word=(((unsigned int)urt->rMessage[oJQT+1]<<8)|urt->rMessage[oJQT]);		//   .
			_JQT=((float)Word)/10;  		
			
			_BDET=(urt->rMessage[oBDET]);						// Code=09    	
			_PABS=urt->rMessage[oPABS];						// 1 	Byte1    
			E=(urt->rMessage[oCOEFF1]);_COEFF1=(E+128)/256;   //  . .
			E=(urt->rMessage[oCOEFF2]);_COEFF2=(E+128)/256;   //  . .
			_LAM1=(urt->rMessage[oLAM1]);					//   L- 1
			_LAM2=(urt->rMessage[oLAM2]);					//   L- 2
			_FAZ=(urt->rMessage[oFAZ])*6;						// 
		if (SR==0) {
			SR=SRMAX;
			_JDMM=(unsigned char)urt->rMessage[oJDMM];		//  -  
			_JEGR=(unsigned char)urt->rMessage[oJEGR];		//     	%
			_JADS=(unsigned char)urt->rMessage[oJADS];		//    	%
//			_RCOK=(((float)abs((int)urt->rMessage[oRCOK]-128))/256.0)-0.5; //   				
//			_RCOD=(((float)abs((int)urt->rMessage[oRCOD]-128))/256.0)-0.5; //      	 
			_RCOK=(float)((signed char)urt->rMessage[oRCOK])/256.0; //   				
			_RCOD=(float)((signed char)urt->rMessage[oRCOD])/256.0; //      	 
			_UOZOC=((float)(char)urt->rMessage[oUOZOC])/2.0;		// 1 	Byte1/2  , 	
		}
/*/*/
//			fprintf(stream,"\r\n EXBPORT:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pEXBPORT;
//		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
//		Sleep(50);	fprintf(stream,"\r\n VALF:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pVALF;
//		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
/*		Sleep(50);	fprintf(stream,"\r\n RCOD:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pRCOD;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n JSPEED:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pJSPEED;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n UGB:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pUGB;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n INJ:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pINJ;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n JAIR:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pJAIR;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n JQT:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pJQT;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n FAZ:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pFAZ;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n BDET:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pBDET;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n JDMM:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pJDMM;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n PABS:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pPABS;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n LAM1:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pJALAM1;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n LAM2:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pJALAM2;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n COEFF1:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pCOEF1;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		Sleep(50);	fprintf(stream,"\r\n COEFF2:");	urt->sMessage[0]=CREADP; urt->sMessage[1]=pCOEF2;
		urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes(); for(i=0;i<5;i++) fprintf(stream, "0x%X, ",urt->rMessage[i]);
		fclose(stream);
*/

		if (SR==0) SR=SRMAX;
			else SR--;
IdleTimer=FALSE;
		return 0;
		}
	}

 if(urt->FrameNotReceived) {  onLooseConnect();}
}
if (SR==0) SR=SRMAX;
	else SR--;
IdleTimer=FALSE;
return -1;
}

/***********************************************************************/

BOOL	mt::ReadVIN() { 

CString	s;
int	i;	
if (!Connected)		return FALSE;
if (sVIN.Present)	return TRUE;
IdleTimer=TRUE;
sVIN.progPasp[0]=0;sVIN.MikasType[0]=0;sVIN.dataPasp[0]=0;
sVIN.vNAMEBL[0]=0; sVIN.vNUMBL[0]=0; sVIN.vDATBL[0]=0; sVIN.vKADC0[0]=0; sVIN.vNUMENG[0]=0; sVIN.vNUMCAR[0]=0; sVIN.vDATENG[0]=0;

	Sleep(100);
	urt->sMessage[0]=MIDENT; urt->SendBytesGAZ(1);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if(!urt->FrameNotReceived) 
	{ //    .
		switch(urt->rMessage[0])
		{
		case MVer54: strcpy(sVIN.MikasType," 5.4"); break;
		case MVer71: strcpy(sVIN.MikasType," 7.1"); break;
		default:	 strcpy(sVIN.MikasType," ?.?");
		}
	}
	else StateText=".  .";

	for(i=0;i<3;i++){
		Sleep(100);
		urt->sMessage[0]=CPASP+i; urt->SendBytesGAZ(1);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
		if((!urt->FrameNotReceived) )
		{ 	sVIN.Present=-1;
			urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi(); s+="\r\n";
			strncat(&sVIN.progPasp[0], LPCSTR(s),18); 
		}
	}

	for(i=0;i<5;i++){
		Sleep(100);
		urt->sMessage[0]=CPASD+i; urt->SendBytesGAZ(1);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
		if((!urt->FrameNotReceived) )
		{ 	sVIN.Present=-1;
			urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi(); s+="\r\n";
			strncat(&sVIN.dataPasp[0], LPCSTR(s),18);  
		}
	}
	//  
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=NAMEBL; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vNAMEBL[0], LPCSTR(s),18);  
	}
	//   
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=NUMBL; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vNUMBL[0], LPCSTR(s),18);  
	}
	//   
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=DATBL; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vDATBL[0], LPCSTR(s),18);  
	}
	//  ADC
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=KADC0; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vKADC0[0], LPCSTR(s),18);  
	}
	//  
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=NUMENG; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vNUMENG[0], LPCSTR(s),18);  
	}
	//  
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=NUMCAR; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vNUMCAR[0], LPCSTR(s),18);  
	}
	//   
	Sleep(100);
	urt->sMessage[0]=CREADP; urt->sMessage[1]=DATENG; urt->SendBytesGAZ(2);	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if((!urt->FrameNotReceived) )
	{ 	urt->rMessage[16]=0; s=&urt->rMessage[0]; s.OemToAnsi();
		strncat(&sVIN.vDATENG[0], LPCSTR(s),18);  
	}

IdleTimer=FALSE;
if (sVIN.Present) return TRUE;
else	return FALSE; 
}

/***********************************************************************/

void mt::ReadControls() //   .
{
return;
// if ( (_EBN=ECO_ReadControl(FPROC))==-1 )			_EBN=1;
//	if ( (_FAN=ECO_ReadControl(CSFROC))==-1 )			_FAN=0;
//	if ( (_CHECKEIGINE=ECO_ReadControl(MILOC))==-1 )	_CHECKEIGINE=FALSE;
//	if ( (_ADSORBER=ECO_ReadControl(CPVOC))==-1 )		_ADSORBER=0;
	if (!RDVChanged) _RDV=_FSM; 
//	_F1 = TRUE;	_F2 = TRUE;	_F3 = TRUE;	_F4 = TRUE;
//	_I14 = TRUE;	_I23 = TRUE;	
}

/***********************************************************************/

mt::OnStart() 
{
	if (COM_Port==0) { COM_Port=2; }
	if (urt->InitUart(COM_Port)!=0) return 0; 
	sVIN.Present=0;
	FirstO2=TRUE; 
	if (M154N) O2offset=2;
			else O2offset=0;
	WasCommStart=FALSE;
	FREQXXChanged=FALSE; 
	RDVChanged=FALSE;
	Connected=FALSE;
	onLooseConnect();
	SetTesterStateText("...");
	Sleep(100);
	TryConnect();
	TesterPresent();
	ReadControls();
	ReadParams(); 
	ReadErrors(); 
	return 1;
}


/***********************************************************************/

void mt::RetCtrl()
{
if (!Connected) TryConnect();

PORTc=PORTx=FORx=Lc=Mc=PROGx=0;
_CONDITION=FALSE;
IdleTimer=TRUE;
SR=0;
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXBPORT;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) { Sleep(100); urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXCPORT;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) { Sleep(100); urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXCL;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);  
	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) { Sleep(100); urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXCM;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) { Sleep(100); urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXCM;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) { Sleep(100); urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXCFOR;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);  
	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) { Sleep(100);  urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
	Sleep(300);
	urt->sMessage[0]=CWRITP;	urt->sMessage[1]=pEXCPROG;	
	urt->sMessage[2]=0;	
	urt->SendBytesGAZ(3);  
	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) {   urt->SendBytesGAZ(3); urt->SetRxTimeOut(200);		urt->ReceiveBytes(); }
IdleTimer=FALSE;
return;

}

/***********************************************************************/

void mt::SetF1(BOOL *m) 
{	
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP; 
	urt->sMessage[1]=pEXCFOR;
	if (_F1)	FORx|= mEXCFOR1;
		else	FORx&=~mEXCFOR1;
	urt->sMessage[2]=FORx;	
	urt->SendBytesGAZ(3);   urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ( (!urt->FrameNotReceived) & (urt->rMessage[0]==0) ) { _F1=!_F1; }
	*m=_F1;
IdleTimer=FALSE;
return; 
}

void mt::SetF2(BOOL *m) 
{ 
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP; 
	urt->sMessage[1]=pEXCFOR;
	if (_F2)	FORx|= mEXCFOR2;
		else	FORx&=~mEXCFOR2;
	urt->sMessage[2]=FORx;	
	urt->SendBytesGAZ(3);   urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ( (!urt->FrameNotReceived) & (urt->rMessage[0]==0) ) { _F2=!_F2; }
	*m=_F2;
IdleTimer=FALSE;
	return; 
} 

void mt::SetF3(BOOL *m) { 
	IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP; 
	urt->sMessage[1]=pEXCFOR;
	if (_F3)	FORx|= mEXCFOR3;
		else	FORx&=~mEXCFOR3;
	urt->sMessage[2]=FORx;	
	urt->SendBytesGAZ(3);   urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ( (!urt->FrameNotReceived) & (urt->rMessage[0]==0) ) { _F3=!_F3; }
	*m=_F3;
IdleTimer=FALSE;
	return; }

void mt::SetF4(BOOL *m) 
{ 
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP; 
	urt->sMessage[1]=pEXCFOR;
	if (_F4)	FORx|= mEXCFOR4;
		else	FORx&=~mEXCFOR4;
	urt->sMessage[2]=FORx;	
	urt->SendBytesGAZ(3);   urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ( (!urt->FrameNotReceived) & (urt->rMessage[0]==0) ) { _F4=!_F4; }
	*m=_F4;
IdleTimer=FALSE;
	return; 
}
/***************************************************************************/
void mt::SetI14(BOOL *m) 
{ 
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPORT;	
	PORTc|=mB1;
	urt->sMessage[2]=PORTc;
	urt->sMessage[3]=pEXBPORT;	
	if (!_I14)  PORTx|=mB1; 
				else	PORTx&=(~mB1);
	urt->sMessage[4]=PORTx;	
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { _I14=!_I14; }
	*m=_I14;
IdleTimer=FALSE;
	return;
}
void mt::SetI23(BOOL *m) 
{ 
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPORT;	
	PORTc|=mB2;
	urt->sMessage[2]=PORTc;
	urt->sMessage[3]=pEXBPORT;	
	if (!_I23)  PORTx|=mB2; 
				else	PORTx&=(~mB2);
	urt->sMessage[4]=PORTx;	
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { _I23=!_I23; }
	*m=_I23;
IdleTimer=FALSE;
	return;
}
/*****************************************************************************/
mt::OnCheckeigine(BOOL *m)	
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPORT;	
	PORTc|=mEXCALA;
	urt->sMessage[2]=PORTc;
	urt->sMessage[3]=pEXBPORT;	
	if (!_CHECKEIGINE)  PORTx|=mALA; 
				else	PORTx&=(~mALA);
	urt->sMessage[4]=PORTx;	
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { _CHECKEIGINE=!_CHECKEIGINE; }
	*m=_CHECKEIGINE;
IdleTimer=FALSE;
return *m;
}

/*****************************************************************************/
mt::OnEbn(BOOL *m)			
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPORT;	
	PORTc|=mPOM;
	urt->sMessage[2]=PORTc;
	urt->sMessage[3]=pEXBPORT;	
	if (!_EBN)  PORTx|=mPOM; 
				else	PORTx&=(~mPOM);
	urt->sMessage[4]=PORTx;	
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { _EBN=!_EBN; }
	*m=_EBN;
IdleTimer=FALSE;
	return 0;
}

/*****************************************************************************/
mt::OnCondition(BOOL *m)	
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPORT;	
	PORTc|=mEXCKON;
	urt->sMessage[2]=PORTc;
	urt->sMessage[3]=pEXBPORT;	
	if (!_CONDITION)	PORTx|=mKON; 
				else	PORTx&=(~mKON);
	urt->sMessage[4]=PORTx;	
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { _CONDITION=!_CONDITION; }
	*m=_CONDITION;
IdleTimer=FALSE;
return 0;
}

/*********************************************************************************/
mt::OnAdsorber(BOOL *m)		{
unsigned int i;
	*m=!m;
	if (*m)	i=100;
			else i=0;
	OnSaveJADS(i);
	SR=0;
	return 0;
}

/*********************************************************************************/
mt::OnFan(BOOL *m)			{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPORT;	
	PORTc|=mEXCFAN;
	urt->sMessage[2]=PORTc;
	urt->sMessage[3]=pEXBPORT;	
	if (!_FAN)	PORTx|=mFAN; 
				else	PORTx&=(~mFAN);
	urt->sMessage[4]=PORTx;	
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { _FAN=!_FAN; }
	*m=_FAN;
IdleTimer=FALSE;
return 0;
}


/*********************************************************************************/
mt::OnLZond(BOOL *m)			
{
IdleTimer=TRUE;
SR=0;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPROG;	
	if (!*m)  	PROGx|=mEXCLAM; 
		else	PROGx&=(~mEXCLAM);
	urt->sMessage[2]=PROGx;	
	urt->SendBytesGAZ(3);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { *m=!*m; }
IdleTimer=FALSE;
return 0;
}

/*********************************************************************************/

BOOL	mt::ClrLZondAdopt()			
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPROG;	
	urt->sMessage[2]=mEXCCLAM;	
	urt->SendBytesGAZ(3);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
IdleTimer=FALSE;
SR=0;
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) return 1; 
		else { StateText="..L-."; return 0;}
return 1;
}

/*********************************************************************************/

mt::OnDeton(BOOL *m)			
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPROG;	
	if (!*m)	PROGx|=mEXCDET; 
		PROGx&=(~mEXCDET);
	urt->sMessage[2]=PROGx;	
	urt->SendBytesGAZ(3);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0)) { *m=!*m; }
SR=0;
IdleTimer=FALSE;
return 0;
}

/*********************************************************************************/
BOOL	mt::ClrDetonAdopt()			
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPROG;	
	urt->sMessage[2]=mEXCCDET;	
	urt->SendBytesGAZ(3);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
IdleTimer=FALSE;
	if ((!urt->FrameNotReceived) & (urt->rMessage[0]==0))  	{ return 1;}
		else { StateText="....";  return 0;}
return 1;
}


/*********************************************************************************/
float	mt::OnSaveUOZC(float m) 
{
if (!Connected) return 0;
//     .
int i;
char	cc;
IdleTimer=TRUE;
	Sleep(100);
	i=0;
	if ( m>15 ) m=15;	if ( m<-15 ) m=-15;
	urt->sMessage[i++]=CWRITP;
	if ( (Lc & mEXCUOZOC) == 0) 
	{	
		urt->sMessage[i++]=pEXCL;
		Lc|=mEXCUOZOC;
		urt->sMessage[i++]=Lc;
	}
	urt->sMessage[i++]=pUOZOC;
//	if (m>0) m=m+0.003;
//	if (m<0) m=m-0.003;
	
	urt->sMessage[i++]=(char)((m)*2);	
	urt->SendBytesGAZ(i);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	if (urt->rMessage[0]!=0) StateText=". . UOZC.";
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pUOZOC;	
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . UOZC.";
		else _UOZOC=(float)((char)urt->rMessage[0])/2.0;		
SR=0;
IdleTimer=FALSE;
return _UOZOC;
}

/*********************************************************************************/
float	mt::OnSaveRCOD(float m) 
{
int i;
signed char	M;

if (!Connected) return 0;
IdleTimer=TRUE;
	Sleep(100);
	i=0;
	urt->sMessage[i++]=CWRITP;
	if ( (Mc & mEXCRCOD) == 0) 
	{	
		urt->sMessage[i++]=pEXCM;
		Mc|=mEXCRCOD;
		urt->sMessage[i++]=Mc;
	}
	else {	
		urt->sMessage[i++]=pEXCM;
		urt->sMessage[i++]=Mc;
	}
	urt->sMessage[i++]=pRCOD;	

	if ( m>=0.5 ) m=0.4995;	if ( m<(-0.5) ) m=-0.4995;
	if (m>=0)		M=(m+0.0001)*256.0;
	else if (m<0)	M=(m-0.0001)*256.0;

//	E=((*m)+0.5)*256.0;	if (E>127)  E=127.0;	if (E<-128) E=-128.0;	E=E+128;
	urt->sMessage[i++]=M;	
	urt->SendBytesGAZ(i);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	if (urt->rMessage[0]!=0) StateText=". . RCOD.";
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pRCOD;
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . RCOD.";
		else _RCOD=(float)((signed char)urt->rMessage[0])/256.0;		
SR=0;
IdleTimer=FALSE;
return _RCOD;
}

/*********************************************************************************/
float	mt::OnSaveRCOK(float m) 
{
int i;
signed char	M;

if (!Connected) return 0;

IdleTimer=TRUE;
	Sleep(100);
	i=0;
	urt->sMessage[i++]=CWRITP;
	if ( (Mc & mEXCRCOK) == 0) 
	{	
		urt->sMessage[i++]=pEXCM;
		Mc|=mEXCRCOK;
		urt->sMessage[i++]=Mc;
	}
	else {	urt->sMessage[i++]=pEXCM;		
			urt->sMessage[i++]=Mc;	}

	urt->sMessage[i++]=pRCOK;	

	if ( m>=0.5 ) m=0.4995;	if ( m<(-0.5) ) m=-0.4995;
	if (m>=0)		M=(m+0.0001)*256.0;
	else if (m<0)	M=(m-0.0001)*256.0;
//	E=(m+0.5)*256;	if (E>127)  E=127.0;	if (E<-128) E=-128.0;	E=E+128;
	urt->sMessage[i++]=M;	
	urt->SendBytesGAZ(i);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	if (urt->rMessage[0]!=0) StateText=". . RCOK.";
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pRCOK;
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . RCOK.";
		else _RCOK=((float)((signed char)urt->rMessage[0]))/256.0;		
SR=0;
IdleTimer=FALSE;
return _RCOK;
}

/**********************************************************************************/

float mt::RCOxChg(int pos,float m)
{
signed char	M;
float Et;
	if ( m>=0.5 ) m=0.4995;	if ( m<(-0.5) ) m=-0.4995;
	if (m>=0)	M=(m+0.0001)*256.0;
	else if (m<0)	M=(m-0.0001)*256.0;
	M=M+pos;
	Et=((float)((char)M)/256.0);
return Et;
}

/**********************************************************************************/

float	mt::StoreRCOD() 
{
if (!Connected) return 0;
     if(! StoreParam(0x01) )	if (urt->rMessage[0]!=0) StateText=". coxp. RCOD.";
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pRCOD;
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . RCOD.";
		else _RCOD=(float)((signed char)urt->rMessage[0])/256.0;		
SR=0;
IdleTimer=FALSE;
return _RCOD;
}


/**********************************************************************************/


float	mt::StoreRCOK() 
{
if (!Connected) return 0;
//     .
     if(! StoreParam(0x02) )	if (urt->rMessage[0]!=0) StateText=". coxp. RCOK.";
IdleTimer=TRUE;
	Sleep(60);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pRCOK;
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . RCOK.";
		else _RCOK=(float)((signed char)urt->rMessage[0])/256.0;		
SR=0;
IdleTimer=FALSE;
return _RCOK;
}

/*********************************************************************************/
unsigned int	mt::OnSaveJEGR(unsigned int m) 
{
int i;
if (!Connected) return 0;
IdleTimer=TRUE;
	Sleep(200);
	i=0;
	if ( m>100 ) m=100;
	urt->sMessage[i++]=CWRITP;
	if ( (Mc & mEXCJEGR) == 0) 
	{	
		urt->sMessage[i++]=pEXCM;
		Mc|=mEXCJEGR;
		urt->sMessage[i++]=Mc;
	}
	urt->sMessage[i++]=pJEGR;	
	urt->sMessage[i++]=m;	
	urt->SendBytesGAZ(i);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	if (urt->rMessage[0]!=0) StateText=". . JEGR.";
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pJEGR;
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . JEGR.";
		else _JEGR=urt->rMessage[0];		
SR=0;
IdleTimer=FALSE;
return _JEGR;
}

/*********************************************************************************/
unsigned int	mt::OnSaveJADS(unsigned int m) 
{
int i;
if (!Connected) return 0;
IdleTimer=TRUE;
	Sleep(200);
	i=0;
	if ( m>100 ) m=100;
	urt->sMessage[i++]=CWRITP;
	if ( (Mc & mEXCJADS) == 0) 
	{	
		urt->sMessage[i++]=pEXCM;
		Mc|=mEXCJADS;
		urt->sMessage[i++]=Mc;
	}
	urt->sMessage[i++]=pJADS;	
	urt->sMessage[i++]=m;	
	urt->SendBytesGAZ(i);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	if (urt->rMessage[0]!=0) StateText=". . JADS.";
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pJADS;
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived)	if (urt->rMessage[0]!=0) StateText=". . JADS.";
		else _JADS=urt->rMessage[0];		
SR=0;
IdleTimer=FALSE;
return _JADS;
}

/**********************************************************************************/
int	mt::StoreParam(unsigned char Addr) 
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCPROG;	
	urt->sMessage[2]=mEXCWRENG;	
	urt->sMessage[3]=pWRADJ;	
	urt->sMessage[4]=Addr;		// 
	urt->SendBytesGAZ(5);  	urt->SetRxTimeOut(300);		urt->ReceiveBytes();
 IdleTimer=FALSE;
     if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	
		 if (urt->rMessage[0]!=0) return 0;
return 1;
}

/**********************************************************************************/
float	mt::StoreUOZC() 
{
if (!Connected) return 0;
//     .
 
     if(! StoreParam(0x03) )	if (urt->rMessage[0]!=0) StateText=". coxp. UOZC.";
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CREADP;	
	urt->sMessage[1]=pUOZOC;	
	urt->SendBytesGAZ(2);  	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
     if(urt->FrameNotReceived )	if (urt->rMessage[0]!=0) StateText=". . UOZC.";
		else _UOZOC=((char)urt->rMessage[oUOZC])/2.0;		
SR=0;
IdleTimer=FALSE;
return _UOZOC;
}

/***********************************************************************/

int	mt::OnSaveRdv(unsigned int m) 
{
if (!Connected) return 0;
//if (!RDVChanged) 
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[0]=CWRITP;	
	urt->sMessage[1]=pEXCL;
	Lc|=mEXCSSM; 
	urt->sMessage[2]=Lc;	
	urt->sMessage[3]=pSSM;
	if(m>255) m=255;
	urt->sMessage[4]=(unsigned char)m;	
	urt->SendBytesGAZ(5);  
	urt->SetRxTimeOut(200);		urt->ReceiveBytes();
    if(urt->FrameNotReceived | (urt->rMessage[0]!=0) )	
	{     
		if (urt->rMessage[0]!=0) StateText=". . .";
	}
RDVChanged=FALSE;
SR=0;
IdleTimer=FALSE;
}
return _RDV;
}

/***********************************************************************/

int	mt::OnSaveFreqxx(unsigned int m) 
{int i=0;
if (!Connected) return 0;
//if (FREQXXChanged) 
{
IdleTimer=TRUE;
	Sleep(100);
	urt->sMessage[i++]=CWRITP;	
	if ( (Lc & mEXCJUFRX) == 0 ) 
	{	urt->sMessage[i++]=pEXCL;	
		Lc|=mEXCJUFRX;
		urt->sMessage[i++]=Lc;
	}
	urt->sMessage[i++]=pJUFRXX;
	if(m>2500) m=2500;
	urt->sMessage[i++]=m/10;	
	urt->SendBytesGAZ(i);  
	urt->SetRxTimeOut(200); urt->ReceiveBytes();
     if(urt->FrameNotReceived  | (urt->rMessage[0]!=0) ) {    if (urt->rMessage[0]!=0) StateText=". . . ";	}
FREQXXChanged=FALSE;
SR=0;
IdleTimer=FALSE;
}
return m;
}

/***********************************************************************/

int mt::ReadState(void)
{
int	i=0;
int	j=0;
if (!Connected) return -1;
	OnStartTest();
	Sleep(50);
	if (Grp!=TESTERGRP) SetTesterGrp();
	urt->sMessage[0]=CREADL; urt->SendBytesGAZ(1);	
	urt->SetRxTimeOut(200); urt->ReceiveBytes();
	if(!urt->FrameNotReceived) 	return 0;
///*/*/	else Connected=FALSE;

SR=0;
return -1;
}

/***********************************************************************/

void mt::SaveRes(struct DTDUMP *DTPar)
{
UINT	Word;	
float	E;

	DTPar->FILL=TRUE;
	DTPar->FREQ=urt->rMessage[oFREQ]*40;
	if (SpeedSensorExist) DTPar->Speed=(unsigned char)urt->rMessage[oSPD];
	else DTPar->Speed=0;
	DTPar->TWAT=(unsigned char)urt->rMessage[oTWAT]-40;
	 Word=((urt->rMessage[oJQT+1]<<8)|urt->rMessage[oJQT]);		//   .
	DTPar->FUEL=((float)Word)/10;
	 Word=((urt->rMessage[oJAIR+1]<<8)|urt->rMessage[oJAIR]);	//   .
	DTPar->AIR=((float)Word)/10;
	DTPar->Time=GetTickCount();
	DTPar->Speed=(unsigned char)urt->rMessage[oJSPEED];
	if (SpeedSensorExist) {
		if(((((unsigned int)urt->rMessage[oJQK+1]<<8)|(unsigned char)urt->rMessage[oJQK])/128) < 350)
			{	
				E=(float)(((unsigned int)urt->rMessage[oJQK+1]<<8)|(unsigned char)urt->rMessage[oJQK]);
				DTPar->FUELK=E/128;//    100 .
			}
			else DTPar->FUELK=0; // .
	}
	else DTPar->FUELK=0; // .
}
/*
			Word=(((unsigned int)urt->rMessage[oJAIR+1]<<8)|urt->rMessage[oJAIR]);	//   .
			_JAIR=((float)Word)/10; 
			Word=(((unsigned int)urt->rMessage[oJQT+1]<<8)|urt->rMessage[oJQT]);		//   .
			_JQT=((float)Word)/10;  		
*/
void mt::OnStopTest()	{ IdleTimer=IdlePresent=FALSE;  }
void mt::OnStartTest()	{ IdleTimer=IdlePresent=TRUE;  }


/***********************************************************************/

char mt::DoDinamicsTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size) 
{
DWORD	Time,Stop;

if (!Connected) return -1;
unsigned int i;
	DTDUMP *DumpPtr;
//	Sleep(200);

	if (ReadState()) { 	OnStopTest(); return -1; }
	if ( (((int)urt->rMessage[oFREQ])*40) > (DTPar->StartFREQ) ) { 	OnStopTest(); return -2;}
	if ( (((int)urt->rMessage[oFREQ])*40) < 400 ) { 	OnStopTest(); return -5; }
	
	DumpPtr=DumpStart;
	memset(DumpPtr,0,sizeof(DTPar)*(Dmp_Size));
	i=0; while (i<Dmp_Size) {DumpPtr->FILL=FALSE; i++; DumpPtr++; }
	DumpPtr=DumpStart;

	//   
	i=0;
	do { if (ReadState()) { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2)) { 	OnStopTest(); return -3; }
	} while ((((int)urt->rMessage[oFREQ])*40) < (DTPar->StartFREQ) );
		//  
	Time=GetTickCount();
	memcpy(StartMessage,urt->rMessage,BUFF_LEN-4);

	SaveRes(DumpPtr);DumpPtr++;

		//   
	do { if (ReadState()) { 	OnStopTest(); return -1;}
	i++; if (i>=(Dmp_Size-2)) { 	OnStopTest(); return -4; }
	SaveRes(DumpPtr);DumpPtr++;
	} while ((((int)urt->rMessage[oFREQ])*40) < (DTPar->StopFREQ) );
	//  
	Stop=GetTickCount();
 	OnStopTest(); 
	DumpPtr--;
	DTPar->BeginFREQ=DumpStart->FREQ;
	DTPar->BeginSpeed=DumpStart->Speed;
	DTPar->BeginTWAT=DumpStart->TWAT;
	DTPar->BeginFUEL=DumpStart->FUEL;
	DTPar->BeginFUELK=DumpStart->FUELK;//    100 .
	DTPar->BeginAIR=DumpStart->AIR;

	DTPar->EndFREQ=DumpPtr->FREQ;
	DTPar->EndSpeed=DumpPtr->Speed;
	DTPar->EndTWAT=DumpPtr->TWAT;
	DTPar->EndFUEL=DumpPtr->FUEL;
	DTPar->EndFUELK=DumpPtr->FUELK;//    100 .
	DTPar->EndAIR=DumpPtr->AIR;

	DTPar->TestTime=Stop-Time;

	return 0;
}

/*******************************************************************************************/

char mt::DoMechTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size) 
{
DWORD	Time,Stop;
DTDUMP *DumpPtr;
unsigned int i;

if (!Connected) return -1;

	DumpPtr=DumpStart;
	memset(DumpStart,0,sizeof(DTPar)*(Dmp_Size));
	i=0; while (i<Dmp_Size) {DumpPtr->FILL=FALSE; i++; DumpPtr++; }
	DumpPtr=DumpStart;

//	Sleep(200);

	if (ReadState())  { 	OnStopTest(); return -1;}
	if ( (((int)urt->rMessage[oFREQ])*40) < 400 )  { 	OnStopTest(); return -5; }
	i=0;
	//    
	do { if (ReadState())  { 	OnStopTest(); return -1;}
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -2;}
	} while ((((int)urt->rMessage[oFREQ])*40) < (DTPar->StartFREQ) );
	//   
	i=0;
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -3; }
	} while ((((int)urt->rMessage[oFREQ])*40) > (DTPar->StartFREQ) );
	//  
	Time=GetTickCount();
	memcpy(StartMessage,urt->rMessage,BUFF_LEN-4);
	SaveRes(DumpPtr);DumpPtr++;

	//   
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -4; }
	SaveRes(DumpPtr);DumpPtr++;
	} while ((((int)urt->rMessage[oFREQ])*40) > (DTPar->StopFREQ) );
	//  
	Stop=GetTickCount();
	OnStopTest(); 
	DumpPtr--;
	DTPar->BeginFREQ=DumpStart->FREQ;
	DTPar->BeginSpeed=DumpStart->Speed;
	DTPar->BeginTWAT=DumpStart->TWAT;
	DTPar->BeginFUEL=DumpStart->FUEL;
	DTPar->BeginFUELK=DumpStart->FUELK;//    100 .
	DTPar->BeginAIR=DumpStart->AIR;

	DTPar->EndFREQ=DumpPtr->FREQ;
	DTPar->EndSpeed=DumpPtr->Speed;
	DTPar->EndTWAT=DumpPtr->TWAT;
	DTPar->EndFUEL=DumpPtr->FUEL;
	DTPar->EndFUELK=DumpPtr->FUELK;//    100 .
	DTPar->EndAIR=DumpPtr->AIR;

	DTPar->TestTime=Stop-Time;
	return 0;
}

/***********************************************************************/

char mt::DoAAccTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size) 
{
DWORD	Time,Stop;

if (!Connected) return -1;
unsigned int i;
	DTDUMP *DumpPtr;
//	Sleep(200);

	if(!SpeedSensorExist)	 { 	OnStopTest(); return -6;}

	if (ReadState())  { 	OnStopTest(); return -1; }
	if ( ((unsigned char)urt->rMessage[oSPD]) > (DTPar->StartFREQ) )  { 	OnStopTest(); return -2; }
	
	DumpPtr=DumpStart;
	memset(DumpStart,0,sizeof(DTPar)*(Dmp_Size));
	i=0; while (i<Dmp_Size) {DumpPtr->FILL=FALSE; i++; DumpPtr++; }
	DumpPtr=DumpStart;

	//   
	i=0;
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -3; }
	} while (((unsigned char)urt->rMessage[oSPD]) < (DTPar->StartFREQ) );
		//  
	Time=GetTickCount();
	memcpy(StartMessage,urt->rMessage,BUFF_LEN-4);

	SaveRes(DumpPtr);DumpPtr++;

		//   
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=Dmp_Size-2)  { 	OnStopTest(); return -4; }
	SaveRes(DumpPtr);DumpPtr++;
	} while (((unsigned char)urt->rMessage[oSPD]) < (DTPar->StopFREQ) );
	//  
	Stop=GetTickCount();
	OnStopTest(); 

	DumpPtr--;
	DTPar->BeginFREQ=DumpStart->FREQ;
	DTPar->BeginSpeed=DumpStart->Speed;
	DTPar->BeginTWAT=DumpStart->TWAT;
	DTPar->BeginFUEL=DumpStart->FUEL;
	DTPar->BeginFUELK=DumpStart->FUELK;//    100 .
	DTPar->BeginAIR=DumpStart->AIR;

	DTPar->EndFREQ=DumpPtr->FREQ;
	DTPar->EndSpeed=DumpPtr->Speed;
	DTPar->EndTWAT=DumpPtr->TWAT;
	DTPar->EndFUEL=DumpPtr->FUEL;
	DTPar->EndFUELK=DumpPtr->FUELK;//    100 .
	DTPar->EndAIR=DumpPtr->AIR;

	DTPar->TestTime=Stop-Time;
	return 0;
}

/*******************************************************************************************/

char mt::DoLAccTest(struct DTPARAMS *DTPar, DTDUMP *DumpStart,unsigned int Dmp_Size) 
{
DWORD	Time,Stop;

DTDUMP *DumpPtr;
unsigned int i;

if (!Connected) return -1;
	if(!SpeedSensorExist)	 { 	OnStopTest(); return -6; }

	DumpPtr=DumpStart;
	memset(DumpStart,0,sizeof(DTPar)*(Dmp_Size));
	i=0; while (i<Dmp_Size) {DumpPtr->FILL=FALSE; i++; DumpPtr++; }
	DumpPtr=DumpStart;

//	Sleep(200);

	i=0;
	//    c
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -2; }
	} while (((unsigned char)urt->rMessage[oSPD]) < (DTPar->StartFREQ) );
	//   
	i=0;
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -3; }
	} while (((unsigned char)urt->rMessage[oSPD]) > (DTPar->StartFREQ) );
	//  
	Time=GetTickCount();
	memcpy(StartMessage,urt->rMessage,BUFF_LEN-4);
	SaveRes(DumpPtr);DumpPtr++;

	//   
	do { if (ReadState())  { 	OnStopTest(); return -1; }
	i++; if (i>=(Dmp_Size-2))  { 	OnStopTest(); return -4; }
	SaveRes(DumpPtr);DumpPtr++;
	} while (((unsigned char)urt->rMessage[oSPD]) > (DTPar->StopFREQ) );
	//  
	Stop=GetTickCount();
	DumpPtr--;
	OnStopTest(); 
	DTPar->BeginFREQ=DumpStart->FREQ;
	DTPar->BeginSpeed=DumpStart->Speed;
	DTPar->BeginTWAT=DumpStart->TWAT;
	DTPar->BeginFUEL=DumpStart->FUEL;
	DTPar->BeginFUELK=DumpStart->FUELK;//    100 .
	DTPar->BeginAIR=DumpStart->AIR;

	DTPar->EndFREQ=DumpPtr->FREQ;
	DTPar->EndSpeed=DumpPtr->Speed;
	DTPar->EndTWAT=DumpPtr->TWAT;
	DTPar->EndFUEL=DumpPtr->FUEL;
	DTPar->EndFUELK=DumpPtr->FUELK;//    100 .
	DTPar->EndAIR=DumpPtr->AIR;

	DTPar->TestTime=Stop-Time;
	return 0;

}

/*******************************************************************************************/

void mt::SetM154N(BOOL m) {
	M154N=m;
	if (M154N) O2offset=2;
	else O2offset=0;
}

