//	 
//		04.07.2000   WakeUp     FO = Sleep(150)  Sleep(25)
//			( )
//
//      5.4.

#include "stdafx.h"

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h> 
//#include <streams.h> 
#include <edevdefs.h>  


#include "Tester.h"
#include "uart.h"

#define RefreshReceive() RMess_Len=RMess_Ptr=0 //   .  

uart::uart()
{
	BadCRC=0;
	NotToTester=0;
	NotFromMIKAS=0;
	FramesReceived=0;
	BytesReceived=0;
	strncpy(PortCom1,"COM1",5); 
	strncpy(PortCom2,"COM2",5); 
	strncpy(PortCom3,"COM3",5); 
	strncpy(PortCom4,"COM4",5); 
	Was40=FALSE;

	pcComPort = NULL;
	hComPort = 0; 
	memset((void *)&m_dcb,0,sizeof(m_dcb));
	memset((void *)&sTimeouts,0,sizeof(sTimeouts));
	UARTErrors=0;
	RxTimeout=20L;
	UartInited=FALSE;
	FrameNotReceived=FALSE;
	Timeout=100; 
}

uart::~uart(){}


void uart::ErrMessageBox(char *TitleString)
{
	UARTErrors++;
/*
LPVOID lpMsgBuf;
	if (UARTErrors>2) return;
        	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,			NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),(LPTSTR)&lpMsgBuf,0,NULL );
				MessageBox( NULL, (LPCTSTR)lpMsgBuf, TitleString , MB_OK | MB_ICONSTOP );
				LocalFree( lpMsgBuf );	
*/
}
/*****************************************************/
void uart::CloseUart()
{
	if (!UartInited) return;
	UartInited=FALSE;
  	if (DeleteFile(pcComPort))	{ ErrMessageBox("  COM .");  return; } 
	pcComPort = NULL;
//	UARTErrors=0;
	if ( !CloseHandle( hComPort ) )	{ ErrMessageBox("  COM .");  return; } 
	hComPort = 0; 
 return;  
}

/*****************************************************/
void  uart::FlushUart( void ) 
{ DWORD dwRetByteCnt; 
	DWORD dwCommError; 
	COMSTAT CommStat;
	char buf[256];  

//	UARTErrors=0;
	if (PurgeComm(hComPort, PURGE_RXCLEAR)) { ErrMessageBox(" Purge in FlushUart()."); return; } 
	ClearCommError( hComPort, &dwCommError, &CommStat ); 
	if (CommStat.cbInQue) 
		{ if(!ReadFile(hComPort, buf,(DWORD)CommStat.cbInQue,(LPDWORD)&dwRetByteCnt,(LPOVERLAPPED)NULL)) {ErrMessageBox(" Read in FlushUart()."); return; } 
	}
}  

/************************************************************************/
/*			 	 		*/
/* unchar	InitUart(int *Port)									*/
/* :		    					*/
/*						(COM1=2=DEV_PORT_COM1, COM2=3=DEV_PORT_COM2,...)*/
/* :		0	-  									*/
/*					1	-      			*/
/*					2	-   							*/
/*					3	-   DCB						*/
/*					4	-   					*/
/*					255 - 			*/
/*************************************************************************/
unchar	uart::InitUart(int Port) 
{
	COM_Port=Port;
	if (UartInited) return 0;
	
	switch (Port)
	{ 
	case DEV_PORT_COM1: pcComPort = PortCom1; break; 
	case DEV_PORT_COM2: pcComPort = PortCom2; break; 
	case DEV_PORT_COM3: pcComPort = PortCom3; break; 
	case DEV_PORT_COM4: pcComPort = PortCom4; break; 
	default:  return 1; 
	} 
//    
	if ( (hComPort = CreateFile( pcComPort,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, NULL )) == (HANDLE)-1 )  
			{/*  */ ErrMessageBox("  .");	return 2; }  
//	UARTErrors=0;
//   DCB
	if ( !GetCommState( hComPort, &m_dcb ) ) { CloseUart(); ErrMessageBox("  DCB."); return 3; }  

	m_dcb.BaudRate = 9600;	m_dcb.fBinary = TRUE;  
	m_dcb.fOutxCtsFlow=FALSE;      // CTS output flow control 
    m_dcb.fOutxDsrFlow=FALSE;      // DSR output flow control 
	m_dcb.fDtrControl = DTR_CONTROL_ENABLE; 
	m_dcb.fDsrSensitivity = FALSE;     //	m_dcb.fTXContinueOnXoff=TRUE; // XOFF continues Tx 
	m_dcb.fOutX = FALSE;	m_dcb.fInX = FALSE;     
	m_dcb.fNull = FALSE;	
	m_dcb.fRtsControl = RTS_CONTROL_ENABLE;
	m_dcb.fAbortOnError = FALSE;  m_dcb.ByteSize = 8;     
	m_dcb.fParity=FALSE; 
	m_dcb.Parity = NOPARITY;     // 0-4=no,odd,even,mark,space
	m_dcb.StopBits = ONESTOPBIT;  // 0,1,2 = 1, 1.5, 2 
/*
    DWORD fErrorChar: 1;       // enable error replacement 
*/
	if(!SetCommState(hComPort, &m_dcb))		{	ErrMessageBox("    (9600bps).");	}
	if (!GetCommTimeouts(hComPort, &sTimeouts)){ErrMessageBox("   .");CloseUart();return 5; } 
	sTimeouts.ReadIntervalTimeout = RxTimeout; 
	sTimeouts.ReadTotalTimeoutMultiplier = 1L; 
	sTimeouts.ReadTotalTimeoutConstant = RxTimeout; 
	sTimeouts.WriteTotalTimeoutMultiplier = 0L; 
	sTimeouts.WriteTotalTimeoutConstant = 0L; 
	if (!SetCommTimeouts(hComPort, &sTimeouts)){ErrMessageBox("   .");CloseUart();return 6; } 
	UartInited=TRUE;
	return 0;
}

/************************************************************************************/
//   Wake-Up : 25 .   50 .	

unchar	uart::WakeUpImpuls(int Port) 
{
BOOL	WasInited=FALSE;
LPDWORD	Actual;
unsigned char	WakeupByte;
	
	if (UartInited) {WasInited=TRUE; CloseUart();}

	switch (Port)
	{ 
	case DEV_PORT_COM1: pcComPort = PortCom1; break; 
	case DEV_PORT_COM2: pcComPort = PortCom2; break; 
	case DEV_PORT_COM3: pcComPort = PortCom3; break; 
	case DEV_PORT_COM4: pcComPort = PortCom4; break; 
	default:  return 1; 
	} 
//    
	if ( (hComPort = CreateFile( pcComPort,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, NULL )) == (HANDLE)-1 )  
			{/*  */ ErrMessageBox("   Wakeup.");	
			if (WasInited) InitUart(COM_Port);
			return 2; }  
//   DCB
	if ( !GetCommState( hComPort, &m_dcb ) ) 	{ ErrMessageBox("  DCB Wakeup."); }  

	m_dcb.BaudRate = 200;	m_dcb.fBinary = TRUE;  m_dcb.fOutxCtsFlow=FALSE;      // CTS output flow control 
    m_dcb.fOutxDsrFlow=FALSE;      // DSR output flow control 
	m_dcb.fDtrControl = DTR_CONTROL_DISABLE; m_dcb.fDsrSensitivity = FALSE;     //	m_dcb.fTXContinueOnXoff=TRUE; // XOFF continues Tx 
	m_dcb.fOutX = FALSE;	m_dcb.fInX = FALSE;     
	m_dcb.fNull = FALSE;	
	m_dcb.fRtsControl = RTS_CONTROL_DISABLE;
	m_dcb.fAbortOnError = FALSE;  m_dcb.ByteSize = 8;     
	m_dcb.fParity=FALSE; m_dcb.Parity = NOPARITY;     // 0-4=no,odd,even,mark,space
	m_dcb.StopBits = ONESTOPBIT;  // 0,1,2 = 1, 1.5, 2 
	if(!SetCommState(hComPort, &m_dcb))	ErrMessageBox("    (200bps)  Wakeup.");	

//  Wake-Up : 25 .   50 .	
	WakeupByte=0xF0;
	if ( !WriteFile(hComPort, &WakeupByte,1,(LPDWORD)&Actual,(LPOVERLAPPED)NULL ) ) ErrMessageBox(" Write in COM in WriteBytes() in Wakeup."); 
	Sleep(25);
	
  	if (DeleteFile(pcComPort))	ErrMessageBox("  COM  Wakeup.");   
	pcComPort = NULL;
	if ( !CloseHandle( hComPort ) )	ErrMessageBox("  COM  Wakeup.");  
	hComPort = 0; 

	if (WasInited) {InitUart(COM_Port);	}

	return 0;
}

unchar CRC;

/************************************************************************/
/*			 	     .		*/
/*																		*/
/* unchar	ParseByte(unchar RByte)									*/
/* :		 .										*/
/* :		0	-    						*/
/*					1	-     Dst!=0xF1				*/
/*					2	-     DST!=0x10				*/
/*					3	-   						*/
/*					255 - 			*/
/*************************************************************************/
unchar	uart::ParseByteGAZ(unchar RByte)
{
	BytesReceived++;
	CRC+=RByte;
//     .
	if (Was40==TRUE) {	rMessage[RMess_Ptr-1]+=RByte; Was40=FALSE; 	return 0; }
	else	{rMessage[RMess_Ptr++]=RByte; RMess_Len++;}
	if (RByte == 0x40)	{ Was40=TRUE; return 0; }
//	if (RMess_Ptr < 3) return 0; //     .
	if (RByte == 0x0D)	
	{	//   .
		FramesReceived++;
		if ((signed char)CRC!=0x0D) { BadCRC++; RefreshReceive(); return 3; }
		//   .     
		return (char)0xFF;
	}
	return 0;
}

/************************************************************************/
/*			 	     .		*/
/*																		*/
/* char	ReceiveByte(unchar RByte)										*/
/* :		   UART								*/
/* :		0	-     					*/
/*					1	-      			*/
/*					2	-      			*/
/*					3	-      CRC			*/
/*					255 -     	*/
/*************************************************************************/

unchar uart::ReadByte()
{ 	
	unchar buf[2];
	DWORD	Actual;
	TimeIsOut=FALSE;
	if ( !ReadFile(hComPort, buf,(DWORD)1,(LPDWORD)&Actual,(LPOVERLAPPED)NULL ) ) 
	{ ErrMessageBox(" Read from COM in ReadByte()."); TimeIsOut=TRUE; return 0xFF;}
	if (Actual==0) TimeIsOut=TRUE;
return buf[0];
}


void uart::SetRxTimeOut(unsigned short Time) {	Timeout=Time;	FrameNotReceived=FALSE; }

 /***********************************************************************/
 /*								       									*/
 /*		               UART.					*/
 /*																		*/
 /* void ReceiveBytes(void)												*/
 /* :		  .								*/
 /* :		.													*/
 /*								       									*/
 /***********************************************************************/
       
void uart::ReceiveBytes(void)	
{
	unchar	Byte, State;
	unsigned long Time;
	CRC=0;
	memset(rMessage,0,BUFF_LEN-1);
	Time=0;	RefreshReceive();	State=0; FrameNotReceived=FALSE;
	while ( State != 0xFF  ) 
	{	Byte=ReadByte();
	if ( !TimeIsOut ) { State=ParseByteGAZ(Byte); Time=0;}
		else { Time+=RxTimeout; //sprintf((char *)&t[0],"%ic.",Time); m_wndStatusBar.SetPaneText( 1, (LPCTSTR) &t, TRUE );
			if (Time>=Timeout)	{FrameNotReceived=TRUE; break;}
		}
	}
}


void uart::WriteBytes(unchar *Message_P,unchar Len) 
{
	unchar	buf[BUFF_LEN+2];
	DWORD	Actual;
//	memset(&buf,0,BUFF_LEN-1)
	sMess_Len=Len;
	if ( !WriteFile(hComPort, Message_P,Len,(LPDWORD)&Actual,(LPOVERLAPPED)NULL ) )	
	{ 
		if (Actual!=Len) ErrMessageBox(" Cant Write all bytes to COM in WriteBytes()."); 
		else	ErrMessageBox(" Write in COM in WriteBytes()."); 
		return; 
	} 
	//  
	Sleep(3);
	if ( !ReadFile(hComPort, buf,Len,(LPDWORD)&Actual,(LPOVERLAPPED)NULL ) ) 
	{
		ErrMessageBox(" Read echo from COM in WriteBytes()."); return; 
	} 
	if (Actual!=Len) 
		ErrMessageBox(" Cant read all bytes from COM in WriteBytes()."); 
	else {if (memcmp(Message_P,buf,Len))		
			{	ErrMessageBox("      COM in WriteBytes()."); return; } 

	}
}


/************************************************************************/
/*			 	     .		*/
/*																		*/
/* char	SendBytes(unchar Len)									*/
/* :		  									*/
/*					    				*/
/* 					     Message   .				*/
/* :		0	- 					*/
/*					1 -		 								*/
/*					255 -    				*/
/*************************************************************************/
unchar	uart::SendBytesGAZ(unchar Len)
{
	unchar i, CRC, n;

	n=Len;
	memset(&sMessage[n],0,BUFF_LEN-1-n);
	if ( (n==0) || (n>(BUFF_LEN-5)) ) {return 1;}

	for ( i=0; i!=n; i++ ) 
	{ 
		if (sMessage[i]==0x0D) {n++; memmove(&sMessage[i+1], &sMessage[i], (n-i)); sMessage[i++]=0x40; sMessage[i]=0xCD; } 
		if (sMessage[i]==0x40) {n++; memmove(&sMessage[i+1], &sMessage[i], (n-i)); sMessage[i++]=0x40; sMessage[i]=0x00; } 
	}

	sMessage[n+1]=0x0D;
	//  CRC      
	for ( i=CRC=0; i!=n; i++ ) CRC+=sMessage[i];
	sMessage[n]=-(signed char)CRC;
	//n++;
	WriteBytes(&(sMessage[0]),n+2);
	return 0;
}
